/*********************************************
Projekt : Impulszhler
Version : 1 
Date    : 09.06.2004
Autor  : Dominik Tewiele

Chip type           : AT90S2313
Clock frequency     : 10,240000 MHz
*********************************************/

#include <90s2313.h>
#include <bcd.h>
#include <delay.h>

unsigned char anzeige;
unsigned char temp1;
unsigned long int temp2;
unsigned long int temp3;
unsigned long int impulse; 
unsigned char  bcd[6]; 
unsigned char loop;
unsigned char seg[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7c,0x07,0x7f,0x67};


// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
impulse++;
}

// Timer 1 output compare interrupt service routine
interrupt [TIM1_COMP] void timer1_comp_isr(void)
{
TCNT1H=0;
TCNT1L=0;
temp3=impulse ;
impulse=0;
}



void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=In Func5=In Func6=In Func7=In 
// State0=0 State1=0 State2=0 State3=0 State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0xFF;

// Port D initialization
// Func0=Out Func1=Out Func2=In Func3=In Func4=Out Func5=Out Func6=In 
// State0=0 State1=0 State2=T State3=T State4=0 State5=0 State6=T 
PORTD=0x00;
DDRD=0x33;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 10,000 kHz
// Mode: Normal top=FFFFh
// OC1 output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
//fr 1s: 0x2710  fr 0.1s: 0x02e8 fr 0.01s 0x0064
OCR1H=0x27;     
OCR1L=0x10;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x40;

// Analog Comparator Output: Off
ACSR=0x80;

// Global enable interrupts
 #asm("sei");

while (1)
      {
temp2=temp3;
for (loop=1;loop<6;loop++)
    {bcd[loop]=temp2%10;
      temp2=temp2/10;
     }
    
    if (anzeige == 5) anzeige=0;
    if (anzeige < 2) temp1 = (1 << anzeige);
    if (anzeige > 1) temp1 = (4 << (anzeige));
    ++anzeige ;
    
    
    PORTB=seg[bcd[6-anzeige]];
    PORTD=temp1;
    };


}
